# Dreamhost WP Management Tool

## Development

This project includes a number of helpers in the `Makefile` to streamline common development tasks.

### Local Environment Setup

The following demonstrates setting up and working with a development environment:

```
### create a virtualenv for development

$ make virtualenv

$ source env/bin/activate


### run dhwp cli application

$ dhwp --help


### run pytest / coverage

$ make test
```

#### Docker Environment Setup

Included is a docker-compose environment that includes a database, nginx, 2 PHP
instances (live and stage) and a container for dhwpcli

```
$ docker-compose up
```

Run the dhwp cli tool inside the container environment

```
$ docker-compose run dhwp --help
```

#### Metrics Command

The metrics command can be run on an individual installation

```
$ docker-compose run dhwp -p /wordpress/live metrics -o /wordpress/live/test.json
```

A batch file path can also be passed to the metrics command, this is used for 
generating metrics on multiple installations under multiple users. The batch
is added to a queue and processed 2 at a time until complete and then the output
is all written to a single file.
```
$ docker-compose run dhwp metrics -b "batch-config.yaml"
```

The batch file is a yaml format like below.
```
Output: /wordpress/live/output.json
Installs:
  - Install Id: 12345
    User: dhwp
    Path: /wordpress/live
  - Install Id: 98765
    User: dhwp
    Path: /wordpress/stage
```

#### Extras Command

The extras command can be run to install plugins and themes listed in a config file.
An example plugins.yaml file can be found in the main directory.

```
$ docker-compose run dhwp -p /wordpress/live -c plugins.yaml extras
```
